<!doctype html>
<html lang="en" xmlns:th="http://www.thymeleaf.org">
<head>
    <base th:href="${#request.getContextPath() + '/'}">
    <meta charset="utf-8">
    <meta name="renderer" content="webkit">
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, minimum-scale=1.0, maximum-scale=1.0, user-scalable=0">
    <link rel="stylesheet" href="assets/fonts/font-awesome/css/font-awesome.css"/>
    <link rel="stylesheet" href="assets/layuiadmin/layui/css/layui.css" media="all">
    <link rel="stylesheet" href="assets/layuiadmin/style/admin.css" media="all">
</head>
<body>
<div class="layui-fluid layui-anim layui-anim-fadein">
    <div class="layui-row">
        <div class="layui-col-md12">
            <div class="layui-card">
                <div class="layui-card-body">
                    <div class="test-table-reload-btn" style="margin-bottom: 10px;">
                        <div class="layui-inline">
                            <input type="text" id="keywords" class="layui-input search-item" placeholder="输入关键字">
                        </div>
                        <div class="layui-inline">
                            <input type="text" id="startTime" class="layui-input search-item" placeholder="开始时间" readonly>
                        </div>
                        <div class="layui-inline">
                            <input type="text" id="endTime" class="layui-input search-item" placeholder="结束时间" readonly>
                        </div>
                        <button type="button" id="search" class="layui-btn layui-btn-sm">
                            <i class="fa fa-lg fa-search"></i> 搜索
                        </button>
                    </div>
                    <table class="layui-hide" id="dataTable" lay-filter="dataTable"></table>
                </div>
            </div>
        </div>
    </div>
</div>
<script src="assets/layuiadmin/layui/layui.js"></script>
<script src="assets/js/vendor/viewer/viewer.min.js"></script>
<script>
    layui.config({
        base: 'assets/layuiadmin/'
    }).extend({
        index: 'lib/index'
    }).use(['index', 'table', 'laydate', 'common'], function() {
        var $ = layui.$;
        var $win = $(window);
        var table = layui.table;
        var admin = layui.admin;
        var laydate = layui.laydate;
        var common = layui.common;
        var resizeTimeout = null;
        var tableUrl = 'api/clientexception/listpageclientexception';

        // 初始化表格
        function initTable() {
            table.render({
                elem: '#dataTable',
                id: 'dataTable',
                url: top.restAjax.path(tableUrl, []),
                width: admin.screen() > 1 ? '100%' : '',
                height: $win.height() - 90,
                limit: 20,
                limits: [20, 40, 60, 80, 100, 200],
                request: {
                    pageName: 'page',
                    limitName: 'rows'
                },
                cols: [
                    [
                        {field:'rowNum', width:80, title: '序号', fixed: 'left', align:'center', templet: '<span>{{d.LAY_INDEX}}</span>'},
                        {field: 'gmtCreate', width: 180, title: '异常时间', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field: 'clientClientName', width: 150, title: '名称', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field: 'clientClientVersion', width: 150, title: '客户端版本', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field: 'clientServerIp', width: 150, title: '服务器地址', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field: 'exceptionType', width: 250, title: '异常类型', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field: 'exceptionName', width: 250, title: '异常名称', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null || rowData == '') {
                                    return '-';
                                }
                                return rowData;
                            }
                        },
                        {field: 'isNoticeProjectLeader', width: 100, title: '通知负责人', fixed:'right', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null) {
                                    return '-';
                                }
                                if(rowData == 0) {
                                    return '<button type="button" class="layui-btn layui-btn-danger layui-btn-xs" lay-event="showExceptionEvent">未通知</button>';
                                } else if(rowData == 1) {
                                    return '<span class="layui-badge layui-bg-green">已通知</span>';
                                }
                                return '错误';
                            }
                        },
                        {field: 'isHandle', width: 100, title: '处理状态', fixed:'right', align:'center',
                            templet: function(row) {
                                var rowData = row[this.field];
                                if(typeof(rowData) === 'undefined' || rowData == null) {
                                    return '-';
                                }
                                if(rowData == 0) {
                                    return '<button type="button" class="layui-btn layui-btn-danger layui-btn-xs" lay-event="handleEvent">未处理</button>';
                                } else if(rowData == 1) {
                                    return '<span class="layui-badge layui-bg-green">已处理</span>';
                                }
                                return rowData;
                            }
                        },
                        {field:'opition', width:100, title: '操作', fixed:'right', align:'center',
                            templet: function(item) {
                                return '<button type="button" class="layui-btn layui-btn-normal layui-btn-xs" lay-event="showExceptionEvent">查看异常</button>';
                            }
                        },
                    ]
                ],
                page: true,
                parseData: function(data) {
                    return {
                        'code': 0,
                        'msg': '',
                        'count': data.total,
                        'data': data.rows
                    };
                }
            });
        }
        // 重载表格
        function reloadTable(currentPage) {
            table.reload('dataTable', {
                url: top.restAjax.path(tableUrl, []),
                where: {
                    keywords: $('#keywords').val(),
                    startTime: $('#startTime').val(),
                    endTime: $('#endTime').val()
                },
                page: {
                    curr: currentPage
                },
                height: $win.height() - 90,
            });
        }
        // 初始化日期
        function initDate() {
            // 日期选择
            laydate.render({
                elem: '#startTime',
                format: 'yyyy-MM-dd'
            });
            laydate.render({
                elem: '#endTime',
                format: 'yyyy-MM-dd'
            });
        }
        initTable();
        initDate();
        // 事件 - 页面变化
        $win.on('resize', function() {
            clearTimeout(resizeTimeout);
            resizeTimeout = setTimeout(function() {
                reloadTable();
            }, 500);
        });
        // 事件 - 搜索
        $(document).on('click', '#search', function() {
            reloadTable(1);
        });

        table.on('tool(dataTable)', function(obj) {
            var layEvent = obj.event;
            var data = obj.data;
            if(layEvent === 'showExceptionEvent') {
                top.dialog.open({
                    url: top.restAjax.path('route/clientexception/getclientexception?clientExceptionId={clientExceptionId}', [data.clientExceptionId]),
                    title: '查看异常',
                    width: '90%',
                    height: '90%',
                    onClose: function() {}
                });
            } else if(layEvent === 'handleEvent') {
                top.dialog.confirm('确定标记处理完成吗？', function(index) {
                    top.dialog.close(index);
                    top.restAjax.put(top.restAjax.path('api/clientexception/updateishandlerbyclientexceptionid/{clientExceptionId}', [data.clientExceptionId]), {}, null, function(code, data) {
                        top.dialog.msg('标记成功');
                        reloadTable();
                    }, function(code, data) {
                        top.dialog.msg(data.msg);
                    });
                })
            }
        });
    });
</script>
</body>
</html>